Attribute VB_Name = "ModBitmap"
Option Explicit

Private Declare Function CreateBitmap Lib "gdi32" (ByVal _
        nWidth As Long, ByVal nHeight As Long, ByVal nPlanes _
        As Long, ByVal nBitCount As Long, lpBits As Any) As Long

Private Declare Function SetBkColor Lib "gdi32" (ByVal hdc As _
        Long, ByVal crColor As Long) As Long

Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As _
        Long, ByVal hObject As Long) As Long

Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc _
        As Long) As Long

Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) _
        As Long

Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject _
       As Long) As Long
       
Public Declare Function BitBlt Lib "gdi32" (ByVal hDCDest As _
        Long, ByVal XDest As Long, ByVal YDest As Long, ByVal _
        nWidth As Long, ByVal nHeight As Long, ByVal hDCSrc _
        As Long, ByVal XSrc As Long, ByVal YSrc As Long, ByVal _
        dwRop As Long) As Long
       
'Flags for the BitBlt API.
Const SRCAND = &H8800C6
Const SRCCOPY = &HCC0020
Const NOTSRCCOPY = &H330008
Const SRCERASE = &H440328
Const SRCINVERT = &H660046
Const SRCPAINT = &HEE0086

Public Const Titel = "Programmieren mit Masken"

Private Sub Main()

    #If Win32 Then
        Form1.Show
    #Else
        End
    #End If

End Sub

Public Function Mask(Source As PictureBox, ByVal Color&, _
                     Mask1 As PictureBox, ByVal Mask2 As _
                     PictureBox, ByVal Mask3 As PictureBox) As Boolean
                     
  Dim hDCMask1&, hMask1&, hDCMask2&, hMask2&
  Dim hPrevMask1&, hPrevMask2&, W&, H&
  
  On Error GoTo Err
  
    SetPicSize Source, Mask1
    SetPicSize Source, Mask2
    SetPicSize Source, Mask3

    W = Source.Width
    H = Source.Height
    
    hDCMask1 = CreateCompatibleDC(Mask1.hdc)
    hDCMask2 = CreateCompatibleDC(Mask1.hdc)
    
    hMask1 = CreateBitmap(W, H, 1, 1, ByVal 0&)
    hMask2 = CreateBitmap(W, H, 1, 1, ByVal 0&)
    
    hPrevMask1 = SelectObject(hDCMask1, hMask1)
    hPrevMask2 = SelectObject(hDCMask2, hMask2)

    Call SetBkColor(Source.hdc, Color)
    
    Call BitBlt(hDCMask1, 0, 0, W, H, Source.hdc, _
                0, 0, SRCCOPY)
    
    Call BitBlt(Mask1.hdc, 0, 0, W, H, _
                hDCMask1, 0, 0, SRCCOPY)
         
    Call BitBlt(hDCMask2, 0, 0, W, H, _
                hDCMask1, 0, 0, NOTSRCCOPY)
    
    Call BitBlt(Mask2.hdc, 0, 0, W, H, _
                hDCMask2, 0, 0, SRCCOPY)
    Call BitBlt(Mask3.hdc, 0, 0, W, H, Source.hdc, _
                0, 0, SRCCOPY)
     
    Call BitBlt(Mask3.hdc, 0, 0, W, H, _
                Mask2.hdc, 0, 0, SRCAND)

    Call DeleteObject(SelectObject(hDCMask1, hPrevMask1))
    Call DeleteObject(SelectObject(hDCMask2, hPrevMask2))
    Call DeleteDC(hDCMask1)
    Call DeleteDC(hDCMask2)
    Mask = True
    Exit Function
    
Err:
      
     Call DeleteObject(SelectObject(hDCMask1, hPrevMask1))
     Call DeleteObject(SelectObject(hDCMask2, hPrevMask2))
     Call DeleteDC(hDCMask1)
     Call DeleteDC(hDCMask2)
     Mask = False

     Exit Function
                 
End Function

Private Sub SetPicSize(oSource As Object, oDest As Object, Optional ByVal bAutoRedraw As Variant)
  With oDest
    .Width = oSource.Width
    .Height = oSource.Height
    .Cls
    .Picture = LoadPicture()
    If Not IsMissing(bAutoRedraw) Then .AutoRedraw = bAutoRedraw
  End With
End Sub


